;--- CIA1 Emulation

;===============================================================
.DATA

Align 2

Start1	dw 0  ; 1 = TimerA , 2 = TimerB , 4 = Chain Timers, 8=TOD
;TimerA1 dw 0
;TimerB1 dw 0
EXTRN TimerA1:WORD
EXTRN TimerB1:WORD

CIA1  db 0    ; 1 = IRQ, 2 = VICIRQ
Mask1 db 0

IRQFlag = 1
VICFlag = 2

EXTRN JoyState:BYTE ; db 0FFh
EXTRN JoyStick:BYTE ; db 1

Alarm1  dd 0  ; DCx8..DCxB when (DCxF and 80h>0)
TodDiv1 db 0  ; CountTOD is called by VBlank (should be 50Hz)


;Align 2
;KeyMatrix db 8 dup (0FFh)
;RevMatrix db 8 dup (0FFh)

EXTRN KeyMatrix:BYTE
EXTRN RevMatrix:BYTE

	   ;  DCx0  DCx1  DCx2  DCx3  DCx4  DCx5  DCx6  DCx7
PokeCIA1  dw wDCxx,wDCxx,wDCxx,wDCxx,wDCxx,wDCx5,wDCxx,wDCx7
	   ;  DCx8  DCx9  DCxA  DCxB  DCxC  DCxD  DCxE  DCxF
	  dw wDCx8,wDCx9,wDCx9,wDCx9,wDCxC,wDCxD,wDCxE,wDCxF

	   ;  DCx0  DCx1  DCx2  DCx3  DCx4  DCx5  DCx6  DCx7
PeekCIA1  dw rDCx0,rDCx1,rDCxx,rDCxx,rDCx4,rDCx5,rDCx6,rDCx7
	   ;  DCx8  DCx9  DCxA  DCxB  DCxC  DCxD  DCxE  DCxF
	  dw rDCxx,rDCxx,rDCxx,rDCxx,rDCxx,rDCxD,rDCxx,rDCxx

abIncTab  db 01h,02h,03h,04h,05h,06h,07h,08h,09h,10h,0Bh,0Ch,0Dh,0Eh,0Fh,00h
          db 11h,12h,13h,14h,15h,16h,17h,18h,19h,20h,1Bh,1Ch,1Dh,1Eh,1Fh,10h
          db 21h,22h,23h,24h,25h,26h,27h,28h,29h,30h,2Bh,2Ch,2Dh,2Eh,2Fh,20h
          db 31h,32h,33h,34h,35h,36h,37h,38h,39h,40h,3Bh,3Ch,3Dh,3Eh,3Fh,30h
          db 41h,42h,43h,44h,45h,46h,47h,48h,49h,50h,4Bh,4Ch,4Dh,4Eh,4Fh,40h
          db 51h,52h,53h,54h,55h,56h,57h,58h,59h,00h,5Bh,5Ch,5Dh,5Eh,5Fh,50h
          db 61h,62h,63h,64h,65h,66h,67h,68h,69h,70h,6Bh,6Ch,6Dh,6Eh,6Fh,60h
          db 71h,72h,73h,74h,75h,76h,77h,78h,79h,00h,7Bh,7Ch,7Dh,7Eh,7Fh,70h
abHour    db 01h,02h,03h,04h,05h,06h,07h,08h,09h,10h,0Bh,0Ch,0Dh,0Eh,0Fh,00h
          db 11h,92h,01h,14h,15h,16h,17h,18h,19h,1Ah,0Bh,0Ch,0Dh,0Eh,0Fh,00h

;===============================================================
.CODE

BEGINP ResetCIA1
 XOR EAX,EAX
 DEC EAX
 MOV DWORD PTR KeyMatrix,EAX
 MOV DWORD PTR KeyMatrix+4,EAX
 MOV DWORD PTR RevMatrix,EAX
 MOV DWORD PTR RevMatrix+4,EAX
 MOV JoyState,0FFh
ResetCIA1 ENDP

;BCD-Zeit in EAX um 1/10 sec erhhen
BEGINP IncTime ; From PC64 :)
  cmp AL,09h
  je @@IncSec
  inc AL
  and AL,00001111b
  jmp @@Return
@@IncSec:
  xor AL,AL                             ;Sekunden erhhen
  mov BL,AH
  xor BH,BH
  mov AH,abIncTab[BX]
  and AH,AH
  jne @@Return
  ror EAX,16                            ;Minuten erhhen
  mov BL,AL
  mov AL,abIncTab[BX]
  and AL,AL
  jne @@RetNRoll
  mov BL,AH                             ;Stunden erhhen
  and BL,00011111b
  and AH,10000000b
  xor AH,abHour[BX]
@@RetNRoll:
  rol EAX,16
@@Return:
  ret
IncTime endp


BEGINP CIA1Line

 MOV CX,Cycles ; Just set by VIC.DrawLine...

;-- Timer A
 TEST Start1,1
 JZ SkipTimerA1

  SUB TimerA1,CX     ; Timer A
  JNS SkipTimerA1

  MOV AX,CIO:[0DC04h] ; Reset Timer
  MOV TimerA1,AX

  MOV  AL,CIO:[0DC0Eh] ; Control Register A
  TEST AL,8
  JZ ContinueA1
   AND AL,0FEh
   MOV CIO:[0DC0Eh],AL
   AND Start1,2+4
  ContinueA1:

  OR byte ptr CIO:[0DC0Dh],1   ; IRQ Control Register
  TEST Mask1,1
  JZ NoIRQA
   OR byte ptr CIO:[0DC0Dh],80h
   OR CIA1,IRQFlag
  NoIRQA:

  TEST Start1,4
  JZ SkipTimerA1

  MOV CX,1
  JMP DoTimerB1

 SkipTimerA1:

;-- Timer B
 TEST Start1,2
 JZ SkipTimerB1

 DoTimerB1:

  SUB TimerB1,CX
  JNS SkipTimerB1

  MOV AX,CIO:[0DC06h]
  MOV TimerB1,AX

  MOV  AL,CIO:[0DC0Fh] ; Control Register
  TEST AL,8
  JZ ContinueB1
   AND AL,0FEh
   MOV CIO:[0DC0Fh],AL
   AND Start1,1
  ContinueB1:

  OR byte ptr CIO:[0DC0Dh],2   ; IRQ Control Register
  TEST Mask1,2
  JZ NoIRQB
   OR byte ptr CIO:[0DC0Dh],80h
   OR CIA1,IRQFlag
  NoIRQB:

 SkipTimerB1:

 RET
CIA1Line ENDP

;===============================================================
BEGINP CheckIRQ
 TEST CIA1,IRQFlag+VICFlag ;--- IRQ (TimerA or RasterIRQ)
 JZ   NoIRQ
 TEST P,IFlag
 JNZ  NoIRQ

  IF DEBUG
   CALLP dbgIRQ
  ENDIF

  AND CIA1,255-IRQFlag-VICFlag
  MOV BX,S
  MOV AX,PC

  MOV RAM:[BX],AH
  DEC BL
  MOV RAM:[BX],AL
  DEC BL

  MOV AL,P
  MOV RAM:[BX],AL
  DEC BL
  MOV S,BX
  OR P,IFlag
  MOV BX,0FFFEh
  Call DeekBX
  MOV PC,BX
  SUB Cycles,7

 NoIRQ:
 RET
CheckIRQ ENDP

;===============================================================

BEGINP CountTOD1
 TEST Start1,8 ; CountTOD
 JZ   NoTOD1
 DEC TodDiv1
 JS  ProceedTod1
  RET
 ProceedTod1:
  MOV TodDiv1,4
  TEST BYTE PTR CIO:[0DC0Eh],80h ; CR A
  JNZ TodDiv1Ok
   INC TodDiv1
  TodDiv1Ok:

  MOV EAX,CIO:[0DC08h] ; TOD
  Call IncTime
  MOV CIO:[0DC08h],EAX

  CMP EAX,Alarm1
  JNE NoTOD1

   OR byte ptr CIO:[0DC0Dh],4   ; IRQ Control Register
   TEST Mask1,4
   JZ NoTOD1
    OR byte ptr CIO:[0DC0Dh],80h
    OR CIA1,IRQFlag

  NoTOD1:
 RET
CountTOD1 ENDP

;===============================================================
;--- Poke($D000)

BEGINP wDCxx
 MOV CIO:[DI],AL
 JMP Next
wDCxx ENDP

BEGINP wDCx5
 MOV CIO:[DI],AL
 TEST Start1,1
 JNZ SkipDCx5
  MOV AX,CIO:[DI-1]
  MOV TimerA1,AX
 SkipDCx5:
 JMP Next
wDCx5 ENDP

BEGINP wDCx7
 MOV CIO:[DI],AL
 TEST Start1,2
 JNZ SkipDCx7
  MOV AX,CIO:[DI-1]
  MOV TimerB1,AX
 SkipDCx7:
 JMP Next
wDCx7 ENDP

BEGINP wDCx8 ;
 TEST BYTE PTR CIO:[0DC0Fh],80h
 JNZ  wDCx8_Alarm
  MOV CIO:[DI],AL
  OR  Start1,8 ; CountTOD
 JMP Next
wDCx8_Alarm:
 MOV BYTE PTR DS:[Alarm1+DI-0DC08h],AL
 JMP Next
wDCx8 ENDP

BEGINP wDCx9 ; ..xDCxB
 TEST BYTE PTR CIO:[0DC0Fh],80h
 JNZ   wDCx8_Alarm
  MOV CIO:[DI],AL
  AND Start1,255-8 ; CountTOD
 JMP Next
wDCx9 ENDP

BEGINP wDCxC
 MOV CIO:[DI],AL
 OR byte ptr CIO:[DI+1],4   ; IRQ Control Register
 TEST Mask1,4
 JZ wDCxC_done
  OR byte ptr CIO:[DI+1],80h
  OR CIA1,IRQFlag
 wDCxC_done:
 JMP Next
wDCxC ENDP

BEGINP wDCxD

;MOV BYTE PTR CIO:[DI],00h ; Hack for addressing modes that read from the address

 TEST AL,128
 JNZ wDCxD_OrMask
  NOT AL
  AND AL,Mask1
  JMP wDCxD_DoMask
 wDCxD_OrMask:
  AND AL,7Fh
  OR  AL,Mask1

  MOV AH,CIO:[DI]
  AND AH,AL
  AND AH,1Fh
  JZ wDCxD_DoMask

   AND BYTE PTR CIO:[DI],80h
   OR  CIA1,IRQFlag

 wDCxD_DoMask:
 MOV Mask1,AL

 IF DEBUG
  CALLP dbgPokeDC0D
 ENDIF


 JMP Next
wDCxD ENDP

BEGINP wDCxE
 TEST AL,10h
 JZ NotLoadA1
  MOV BX,CIO:[0DC04h]
  MOV TimerA1,BX
 NotLoadA1:
 MOV AH,AL
 AND AL,0EFh
 MOV CIO:[DI],AL
 AND AH,21h
 AND Start1,255-1
 CMP AH,1
 JNE NotStartA1
  OR Start1,1
 NotStartA1:
 JMP Next
wDCxE ENDP

BEGINP wDCxF
 TEST AL,10h
 JZ NotLoadB1
  MOV BX,CIO:[0DC06h]
  MOV TimerB1,AX
 NotLoadB1:
 MOV AH,AL
 AND AL,0EFh
 MOV CIO:[DI],AL
 AND AL,61h
 AND Start1,255-2-4
 CMP AH,1
 JNE NotStartB1
  OR Start1,2
 NotStartB1:
 CMP AH,41h
 JNE NotChain1
  OR Start1,4
 NotChain1:
 JMP Next
wDCxF ENDP

;--- Peek($D000)

BEGINP rDCxx
 MOV AL,CIO:[DI]
 RET
rDCxx ENDP

BEGINP rDCx0
 MOV AX,CIO:[DI]   ; DPA+DPB
 MOV BX,CIO:[DI+2] ; DDA+DDB
 NOT BX
 OR  AX,BX
 TEST Joystick,1
 JZ rDCx0_Joy2
  AND AH,JoyState
 rDCx0_Joy2:
 MOV BX,Offset RevMatrix
 MOV CX,8
 Rev1:
 SHR AH,1
 JC SkipRev1
  AND AL,[BX]
 SkipRev1:
 INC BX
 LOOP Rev1
 TEST Joystick,2
 JZ rDCx0_Joy1
  AND AL,JoyState
 rDCx0_Joy1:
 RET
rDCx0 ENDP

BEGINP rDCx1
 MOV AX,CIO:[0DC02h] ; DDA+DDB
 NOT AX
 OR  AL,CIO:[0DC00h] ; DPA
 XCHG AL,AH
 TEST Joystick,2
 JZ rDCx1_Joy1
  AND AH,JoyState
 rDCx1_Joy1:
 MOV BX,Offset KeyMatrix
 MOV CX,8
 Key1:
 SHR AH,1
 JC SkipKey1
  AND AL,[BX]
 SkipKey1:
 INC BX
 LOOP Key1
 MOV AH,CIO:[0DC01h] ; DPB
 AND AH,CIO:[0DC03h] ; DDB
 OR  AL,AH
 XOR AH,AH ; !!!
 TEST Joystick,1
 JZ rDCx1_Joy2
  AND AL,JoyState
 rDCx1_Joy2:
 RET
rDCx1 ENDP

BEGINP rDCx4
 MOV AL,BYTE PTR TimerA1
 RET
rDCx4 ENDP

BEGINP rDCx5
 MOV AL,BYTE PTR TimerA1+1
 RET
rDCx5 ENDP

BEGINP rDCx6
 MOV AL,BYTE PTR TimerB1
 RET
rDCx6 ENDP

BEGINP rDCx7
 MOV AL,BYTE PTR TimerB1+1
 RET
rDCx7 ENDP

BEGINP rDCxD
 MOV AL,CIO:[DI]
 MOV BYTE PTR CIO:[DI],0
 AND CIA1,255-IRQFlag ; CLEAR IRQ
 RET
rDCxD ENDP

