;-- POKE C64 Memory

;===============================================================
.DATA
Align 2
	      ; 0xxx 1xxx,2xxx,3xxx,4xxx,5xxx,6xxx,7xxx
PokeTable    dw sZPG,sRAM,sRAM,sRAM,sRAM,sRAM,sRAM,sRAM
	      ; 8xxx,9xxx,Axxx,Bxxx,Cxxx,Dxxx,Exxx,Fxxx
	     dw sRAM,sRAM,sRAM,sRAM,sRAM,sCIO,sRAM,sRAM

	      ; D0xx D1xx D2xx D3xx D4xx D5xx D6xx D7xx
PokeCIOTable dw wVIC,wVIC,wVIC,wVIC,wSID,wSID,wSID,wSID
	      ; D8xx D9xx DAxx DBxx DCxx DDxx DExx DFxx
	     dw wCOL,wCOL,wCOL,wCOL,wCI1,wCI2,wCOL,wCOL

;===============================================================
.CODE

;--- POKE(BX)
BEGINP PokeBX
 MOV DI,BX
 SHR BX,12
 JMP32 EBX, PokeTable ;-- JMP [2*EBX+Offset PokeTable]
PokeBX ENDP

;--- POKE(DI) -- for OP ABSO cause the peek destroy BX !!
BEGINP PokeDI
 MOV BX,DI
 SHR BX,12
 JMP32 EBX, PokeTable ;-- JMP [2*EBX+Offset PokeTable]
PokeDI ENDP

BEGINP sZPG
 MOV RAM:[DI],AL
 CMP DI,2
 JB  ConfigMem
 JMP NEXT
sZPG ENDP

;===============================================================
BEGINP ConfigMem
; port:=(not Bank0^[0]) or Bank0^[1];
; if  (Port and 2)=2 then KERNEL :=@KERNEL_ROM  else KERNEL :=@BANK1^[$E000];
; if  (Port and 3)=3 then BASIC  :=@BASIC_ROM   else BASIC  :=@BANK1^[$A000];
; if  (Port and 3)>0 then CHARSET:=@CHARSET_ROM else CHARSET:=@BANK1^[$D000];
; IO:=(Port and 7)>4;

 IF DEBUG
  CALLP dbgCFG
 ENDIF

 MOV AX,RAM:[00]
 NOT AL
 OR  AL,AH

 MOV BX,  0Eh
 MOV DI,2*0Eh

 TEST AL,2
 JNZ SET_KERNAL
  IF DEBUG
   CALLP dbgKOFF
  ENDIF

  MOV WORD PTR [BX+Offset PeekPCTable],Offset pcRAM
  MOV WORD PTR [DI+Offset PeekTable],Offset pRAM
  MOV WORD PTR [DI+Offset DeekTable],Offset dRAM
  MOV WORD PTR [DI+Offset PeekTable+2],Offset pRAM
  MOV WORD PTR [DI+Offset DeekTable+2],Offset dRAM

  MOV BX,  0Ah
  MOV DI,2*0Ah

 REMOVE_BASIC:
  IF DEBUG
   CALLP dbgBOFF
  ENDIF
  MOV WORD PTR [BX+Offset PeekPCTable],Offset pcRAM
  MOV WORD PTR [DI+Offset PeekTable],Offset pRAM
  MOV WORD PTR [DI+Offset DeekTable],Offset dRAM
  MOV WORD PTR [DI+Offset PeekTable+2],Offset pRAM
  MOV WORD PTR [DI+Offset DeekTable+2],Offset dRAM
 JMP KERNAL_DONE

 SET_KERNAL:
  IF DEBUG
   CALLP dbgKON
  ENDIF
  MOV WORD PTR [BX+Offset PeekPCTable],Offset pcROM
  MOV WORD PTR [DI+Offset PeekTable],Offset pROM
  MOV WORD PTR [DI+Offset DeekTable],Offset dROM
  MOV WORD PTR [DI+Offset PeekTable+2],Offset pROM
  MOV WORD PTR [DI+Offset DeekTable+2],Offset dROM

  MOV BX,  0Ah
  MOV DI,2*0Ah

  TEST AL,1
  JZ  REMOVE_BASIC
  IF DEBUG
   CALLP dbgBON
  ENDIF
  MOV WORD PTR [BX+Offset PeekPCTable],Offset pcROM
  MOV WORD PTR [DI+Offset PeekTable],Offset pROM
  MOV WORD PTR [DI+Offset DeekTable],Offset dROM
  MOV WORD PTR [DI+Offset PeekTable+2],Offset pROM
  MOV WORD PTR [DI+Offset DeekTable+2],Offset dROM

 KERNAL_DONE:

 MOV BX,2*0Dh
 MOV AH,AL
 AND AH,3
 JNZ SET_CHARS
  MOV WORD PTR [BX+Offset PeekTable],Offset pRAM
  MOV WORD PTR [BX+Offset DeekTable],Offset dRAM
  JMP CHARS_DONE
 SET_CHARS:
  MOV WORD PTR [BX+Offset PeekTable],Offset pROM
  MOV WORD PTR [BX+Offset DeekTable],Offset dROM
  JMP CHARS_DONE
 CHARS_DONE:

 MOV BX,2*0Dh
 AND AL,7
 CMP AL,4
 JA  SET_CHIPS
  MOV WORD PTR [BX+Offset PokeTable],Offset sRAM
  JMP NEXT
 SET_CHIPS:
 MOV WORD PTR [BX+Offset PeekTable],Offset pCIO
 MOV WORD PTR [BX+Offset DeekTable],Offset dCIO
 MOV WORD PTR [BX+Offset PokeTable],Offset sCIO

 JMP NEXT
ConfigMem ENDP

BEGINP sRAM
 MOV RAM:[DI],AL
 JMP NEXT
sRAM ENDP

;--- POKE($Dxxx)
BEGINP sCIO
 MOV BX,DI
 SHR BX,8
 AND BX,0Fh
 JMP32 EBX, PokeCIOTable ;-- JMP [2*EBX+Offset PokeCIOTable]
sCIO ENDP

BEGINP wVIC
 AND DI,0F03Fh ; Patch VIC Adresse !
 MOV BX,DI
 AND BX,03Fh
 JMP32 EBX, PokeVICTable ;-- JMP [2*EBX+Offset PokeVICTable]
wVIC ENDP

IFE DEBUG
 .DATA
 EXTRN SIDPoke :BYTE
 EXTRN SIDAddr :WORD
 EXTRN PokeSID :FAR
 .CODE
ENDIF

BEGINP wSID
 AND DI,0D41Fh ; Patch SID Adresse !

 MOV AH,CIO:[DI]
 MOV CIO:[DI],AL

 AND DI,001Fh
IFE DEBUG
 MOV SIDAddr,DI
 MOV SIDPoke,AL
 CALLP PokeSID
ENDIF
 JMP NEXT
wSID ENDP

BEGINP wCOL
 AND AL,15
 MOV CIO:[DI],AL
 JMP NEXT
wCOL ENDP

BEGINP wCI1
 AND DI,0FF0Fh ; Patch CIA Adresse !
 MOV BX,DI
 AND BX,15
 JMP32 EBX, PokeCIA1 ;-- JMP [2*EBX+Offset PokeCIA1]
wCI1 ENDP

BEGINP wCI2
 AND DI,0FF0Fh ; Patch CIA Adresse !
 MOV BX,DI
 AND BX,15
 JMP32 EBX, PokeCIA2 ;-- JMP [2*EBX+Offset PokeCIA2]
wCI2 ENDP

