Unit T64;

{ LOAD -> E168
  E168 -> FFD5 - Load from Device
                 CFlag on error (A=Msg) -> E1D1 -> E0F9
  FFD5 -> F49E - Load at XY
  F49E -> (0330)-> F4A5
  F4A5 --> F4BF for DISK
       \-> F533 for TAPE

  F533 : F7D0  - Tape buffer XY=(B2:B3)
         F817 : F82E - Tape buttons (BIT (01),$10)

         ...


  F199 - Read on byte from TAPE (buffered)
         Buffer=B2:B3 Index=A6
         F841

  F72C - F841
         CFlag on error
         (ZB2),0=buffer
             5: End of Tape
             1: Program Data
             3: ?
             4: Data Header
         (ZB2),5=Name[16]

  F841 - Read TAPE Block
         Z90=0 (ST BYTE)
         Z93=0 (LOAD,NOT VERIFY)
         F7D7 - Set TAPE I/O (ZAE:ZAF) size=192
          F7D0 - XY=TAPE Buffer
           X=ZB2
           Y=ZB3
          A=X
          ZC1=A (ZB2)
          ADD 192
          ZAE=A (ZB2+192)
          A=Y
          ZC2=A (ZB3)
          ADC 0
          ZAF=A (ZB3+Carry)
         F817 - Press PLAY on Tape.. <- hack select T64 ?
                CFlag on Error
  F84F...SEI
          ZAA,ZB4,ZB0,Z9E,Z9F,Z9C=0
          A=$90 ; ICR1 Flag
          X=$0E ; LOAD
         F875

  F875 - Read/Write on/to TAPE

  F895 ... SAVE IRQ (X=NewIRQ : FCBD)
           FB97
}

Interface

uses
 data,fdos,dialogs;

procedure ReadTape;

Implementation


Type
 THeader=record
  Sign    :array[1.. 3] of char; { 'C64' }
  Text    :array[1..29] of char;
  Version :word;                 { $0101 }
  Entries :word;
  Used    :word;                 { can be 0 }
  Dummy   :word;
  Title   :array[1..24] of char; { For a Menu }
 end;

 TEntry=record
  EntryFlag:byte;                { Empty,Tape,SnapShot }
  C64Type  :byte;
  LoadAddr :word;                { $0801 }
  EndAddr  :word;                { $DC00 }
  Dummy1   :word;
  DataOfs  :longint;             { from begin of file }
  Dummy2   :longint;
  C64Name  :array[1..16] of char;{ File Name }
 end;

Var
 Handle:word;
 T64File:string;

 Header:THeader;
 Entry :TEntry;

 Reading:(rName,rData);

Function ReadHeader:boolean;
 begin
  ReadHeader:=(ReadFile(Handle,Header,SizeOf(Header))=SizeOf(Header))
           and(Header.Sign='C64');
 end;

Function PressPlayOnTape:boolean;
 begin
  if Handle=0 then begin
   if T64File='' then SelectFile('Select a T64 File','T64',T64File);
   if T64File='' then Handle:=0 else Handle:=OpenFile(T64File,fmRead);
   if (Handle=0)or(not ReadHeader) then begin
    CloseFile(Handle);
    Handle :=0;
    P:=P+[CFlag];
   end;
   Reading:=rName;
  end;
  PressPlayonTape:=(Handle>0);
 end;


Procedure ReadTape;
 begin
  P:=P-[CFlag];
  if Not PressPlayOnTape then exit;
  case Reading of
   rName:begin
    if not ReadFile(Handle,Entry,SizeOf(Entry))=SizeOf(Entry) then exit;

   end;
  end;
 end;

end.