Program TAPE64;

uses
 fdos;


Const
 Hexa:array[0..$F] of char='0123456789ABCDEF';

Function HexaB(B:Byte):string;
 begin
  HexaB:=Hexa[B SHR 4]+Hexa[B AND $F];
 end;

Function HexaW(W:Word):string;
 begin
  HexaW:=HexaB(W SHR 8)+HexaB(W AND $FF);
 end;

var
 Handle:word;

 { T64 Format :

   - Header
   - DirEntry
     ... * Header.DirEntries
   - Data
     ... (at DirEntry.DataOfs)

 }

 Header:record
  Sign    :array[1.. 3] of char; { 'C64' }
  Text    :array[1..29] of char;
  Version :word; { $0101 }
  Entries :word;
  Used    :word; { can be 0 }
  Dummy   :word;
  Title   :array[1..24] of char;
 end;

 Entry:record
  EntryFlag:byte; { Empty,Tape,SnapShot }
  C64Type  :byte;
  LoadAddr :word;
  EndAddr  :word;
  Dummy1   :word;
  DataOfs  :longint;
  Dummy2   :longint;
  C64Name  :array[1..16] of char;
 end;

procedure dump(T64:string);
 var
  i:word;
 begin
  Handle:=OpenFile(T64);

  WriteLn('-----------------------------');
  WriteLn(T64,' = ',FileSize(Handle),' octets');

  if (ReadFile(Handle,Header,SizeOf(Header))<>SizeOf(Header))
   or(Header.Sign<>'C64') then begin
   WriteLn('Not a T64 file');
   Closefile(Handle);
   exit;
  end;

  WriteLn('Head    : ',Header.Sign,Header.Text);
  WriteLn('Version : ',Hi(Header.Version),'.',Lo(Header.Version));
  Writeln('Entries : ',Header.Entries);
  Writeln('Used    : ',Header.Used);
  WriteLn('Title   : ',Header.Title);

  WriteLn('  Entries    :');
  for i:=1 to Header.Entries do begin
   If ReadFile(Handle,Entry,SizeOf(Entry))<>SizeOf(Entry) then
    WriteLn('  #',i,' Read error !')
   else with Entry do begin
    if EntryFlag>0 then begin
     WriteLn('  #',i,' ',C64Name);
     WriteLn('   Kind    :',EntryFlag);
     WriteLn('   C64Type :',C64Type);
     WriteLn('   Load at :',HexaW(LoadAddr));
     WriteLn('   End at  :',HexaW(EndAddr));
     WriteLn('   Offset  :',DataOfs);
    end;
   end;
  end;

  CloseFile(Handle);
 end;

begin
 Assign(Output,'TAPE64.TXT'); Rewrite(Output);

 Dump('\EMULATOR\T64\ZORRO.T64');
 Dump('\EMULATOR\T64\GANDAL~1.T64');
 Dump('\EMULATOR\T64\FIST.T64');
 Dump('\EMULATOR\T64\STUNTCAR.T64');
end.