.DATA

TweakParm dw  6B00h ; Horizontal total
          dw  5901h ; Horizontal displayed
          dw  5A02h ; Start horizontal blanking
          dw  8E03h ; end horizontal blanking
          dw  5E04h ; Start H sync.
          dw  8A05h ; end H sync.
          dw  0D06h ; Vertical total
          dw  3E07h ; Overflow
          dw  4109h ; Cell height
          dw 0EA10h ; V sync. start
          dw 0AC11h ; V sync. end/Prot CR0 CR7
          dw 0DF12h ; Vertical displayed
          dw  2D13h ; offset
          dw  0014h ; DWord mode off
          dw 0E715h ; V Blank start
          dw  0616h ; V Blank end
          dw 0E317h ; Turn on Byte mode

GAMMA equ 1
gc equ /4*GAMMA

Palette db 010h gc,010h gc,010h gc; Black - Come Back 64
	db 0FFh gc,0FFh gc,0FFh gc; White
	db 0E0h gc,040h gc,040h gc; Red
	db 060h gc,0FFh gc,0FFh gc; Cyan
	db 0E0h gc,060h gc,0E0h gc; Purple
	db 040h gc,0E0h gc,040h gc; Green
	db 040h gc,040h gc,0E0h gc; blue
	db 0FFh gc,0FFh gc,040h gc; Yellow
	db 0E0h gc,0A0h gc,040h gc; Orange
	db 09Ch gc,074h gc,048h gc; Brown
	db 0FFh gc,0A0h gc,0A0h gc; Lt.Red
	db 054h gc,054h gc,054h gc; Dk.Gray
	db 088h gc,088h gc,088h gc; Gray
	db 0A0h gc,0FFh gc,0A0h gc; Lt.Green
	db 0A0h gc,0A0h gc,0FFh gc; Lt.Blue
	db 0C0h gc,0C0h gc,0C0h gc; Lt.Gray

comment # PC64
Palette db 00h,00h,00h ; 0 - Black
        db 3Fh,3Fh,3Fh ; 1 - White
        db 2Eh,00h,05h ; 2 - Red
        db 00h,30h,2Bh ; 3 - Cyan
        db 25h,00h,26h ; 4 - Purple
        db 09h,33h,00h ; 5 - Green
        db 01h,04h,2Ch ; 6 - Blue
        db 3Fh,3Fh,00h ; 7 - Yellow
        db 26h,15h,00h ; 8 - Orange
        db 14h,08h,05h ; 9 - Brown
        db 3Fh,14h,1Eh ; 10- Lt.Red
        db 12h,12h,12h ; 11- Dk.Grey
        db 1Ch,1Ch,1Ch ; 12- Grey
        db 17h,3Fh,15h ; 13- Lt.Green
        db 15h,1Ch,3Ah ; 14- Lt.Blue
        db 2Bh,2Bh,2Bh ; 15- Lt.Grey
#

.CODE

BEGINP TweakMode
 MOV AX,13h
 INT 10h

;--- setup colors ---

 MOV DX,03C8h
 MOV AL,0
 OUT DX,AL
 INC DX
 MOV SI,offset Palette
 MOV CX,3*16
 REP OUTSB

 MOV DX,03C4h ; Sequencer Register
 MOV AX,0604h ; Disable Chain 4 Mode
 OUT DX,AX

 MOV AX,0100h ; (A)synchronous Rset
 OUT DX,AX

 MOV DX,03C2h ; VGA Misc Register
 MOV AL,0E7h  ; Use 28Mhz Clock & 60Hz
 OUT DX,AL

 MOV DX,03C4h ; Sequencer Register
 MOV AX,0300h ; Restart Sequencer
 OUT DX,AX

 ; Diasable Write protect For CrtC Registers 0-7, since we are
 ; about to change the horizontal & vertical timing settings.

 MOV DX,03D4h ; VHA CrtC Register
 MOV AL,11h   ; CrtC Register 11h
 OUT DX,AL    ; Load current value
 INC DX       ; Point to Data
 IN  AL,DX    ; Get CrtC register 11h
 AND AL,7Fh   ; Mask out Write Protect
 OUT DX,AL    ; and send it back

 ; Send CrtC data in TweakMode array to the CrtC.
 MOV DX,03D4h ; VGA CrtC Register
 CLD          ; Forward Block Load
 MOV SI,offset TweakParm ; Get parameter data
 MOV CX,17    ; Number of entries in block
 REP OUTSW

;--- Clear Screen ---

 MOV DX,03C4h
 MOV AX,0F02h
 OUT DX,AX
 MOV ES,VGASeg
 XOR DI,DI
 XOR AX,AX
 MOV CX,360*240/4*3/2
 REP STOSW

 RET

TweakMode ENDP

BEGINP TextMode
 MOV AX,03h
 INT 10h
 RET
TextMode ENDP
