;-- VIC II Emulation

;====================================================
.DATA

 EXTRN VGASeg :WORD	   ;-- Segment of VGA Card
 EXTRN VGAOfs :WORD
IFE DEBUG
 EXTRN VideoSeg:word       ;-- VGA.PAS
ENDIF
 EXTRN Raster :WORD
 EXTRN ColorMatrix:BYTE    ;-- video buffers
 EXTRN VideoMatrix:BYTE
 EXTRN CharsMatrix:BYTE

 EXTRN Bank     :WORD
 EXTRN VideoOfs :WORD
 EXTRN BitmapOfs:WORD
 EXTRN CharGen  :DWORD

 VideoY     dw 0
 FirstLine  dw 51
 LastLine   dw 250

 YScroll    dw 0  ; 0->7 (Default 3)
 StartLine  dw 51 ; YScroll+51-3 (First Text Line)

 SpriteData db 0,0,0,0, 0,0,0,0 ; local copy of a sprite line

 MultiColor db 0,0,0,0

 SpriteTest db 0 ; Fore/BackGround & Display

 VideoMode  dw TextMode1
 VideoBack  dw TextBack1

             ; 000       001       010        011
 VideoModes dw TextMode1,TextMode2,GraphMode1,GraphMode2
             ; 100       101       110        111
            dw TextMode3,TextMode4,GraphMode3,GraphMode4

             ; 000       001       010        011
 VideoBacks dw TextBack1,TextBack2,GraphBack1,GraphBack2
             ; 100       101       110        111
            dw TextBack3,TextBack4,GraphBack3,GraphBack4

; CharGen    dd 0
 BadBitmap dw 0
 BadColor  dw 0D800h
 BadVideo  dw 00400h

 TextCols  dw 40
 TextRow   dw 0

 IRQRaster dw 0

IF SKIPCOUNT
 SkipFrame dw 1
ENDIF

 TopOfScreen	equ 30	   ; VGA Clipping (360x240)
 BottomOfScreen equ 270

              ;  Dx00, Dx01, Dx02, Dx03, Dx04, Dx05, Dx06, Dx07
PokeVICTable dw wDxxx,wDxxx,wDxxx,wDxxx,wDxxx,wDxxx,wDxxx,wDxxx

              ;  Dx08, Dx09, Dx0A, Dx0B, Dx0C, Dx0D, Dx0E, Dx0F
             dw wDxxx,wDxxx,wDxxx,wDxxx,wDxxx,wDxxx,wDxxx,wDxxx

              ;  Dx10, Dx11, Dx12, Dx13, Dx14, Dx15, Dx16, Dx17
             dw wDxxx,wDx11,wDx12,wDxxx,wDxxx,wDxxx,wDx16,wDxxx

              ;  Dx18, Dx19, Dx1A, Dx1B, Dx1C, Dx1D, Dx1E, Dx1F
             dw wDx18,wDx19,wDx1A,wDxxx,wDxxx,wDxxx,wDxxx,wDxxx

              ;  Dx20, Dx21, Dx22, Dx23, Dx24, Dx25, Dx26, Dx27
             dw wDx2x,wDx2x,wDx2x,wDx2x,wDx2x,wDx2x,wDx2x,wDx2x

              ;  Dx28, Dx29, Dx2A, Dx2B, Dx2C, Dx2D, Dx2E, Dx2F
             dw wDx2x,wDx2x,wDx2x,wDx2x,wDx2x,wDx2x,wDx2x,wDx2x

              ;  Dx30, Dx31, Dx32, Dx33, Dx34, Dx35, Dx36, Dx37
             dw wDxxx,wDxxx,wDxxx,wDxxx,wDxxx,wDxxx,wDxxx,wDxxx

              ;  Dx38, Dx39, Dx3A, Dx3B, Dx3C, Dx3D, Dx3E, Dx3F
             dw wDxxx,wDxxx,wDxxx,wDxxx,wDxxx,wDxxx,wDxxx,wDxxx

              ;  Dx00, Dx01, Dx02, Dx03, Dx04, Dx05, Dx06, Dx07
PeekVICTable dw rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx

              ;  Dx08, Dx09, Dx0A, Dx0B, Dx0C, Dx0D, Dx0E, Dx0F
             dw rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx

              ;  Dx10, Dx11, Dx12, Dx13, Dx14, Dx15, Dx16, Dx17
             dw rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDx16,rDxxx

              ;  Dx18, Dx19, Dx1A, Dx1B, Dx1C, Dx1D, Dx1E, Dx1F
             dw rDx18,rDx19,rDx1A,rDxxx,rDxxx,rDxxx,rDnul,rDnul

              ;  Dx20, Dx21, Dx22, Dx23, Dx24, Dx25, Dx26, Dx27
             dw rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx

              ;  Dx28, Dx29, Dx2A, Dx2B, Dx2C, Dx2D, Dx2E, Dx2F
             dw rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx

              ;  Dx30, Dx31, Dx32, Dx33, Dx34, Dx35, Dx36, Dx37
             dw rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx

              ;  Dx38, Dx39, Dx3A, Dx3B, Dx3C, Dx3D, Dx3E, Dx3F
             dw rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx,rDxxx

 INCLUDE COMPUTE.INC ; Reverse, DoubleH, DoubleL

;====================================================
.CODE

BEGINP UpdateRaster

; Now update Raster

 MOV AX,Raster
 INC AX
 CMP AX,312 ; End Of Screen
 JNE NoVBlank
  Call CountTOD1 ; CIA1
  Call CountTOD2 ; CIA2
 IF DEBUG
  Call ResetCIA1 ; reset KeyMatrix
  CALLP dbgKEYB
 ELSE
  Call CheckKeyboard
 ENDIF

 IF SKIPCOUNT
  DEC SkipFrame
  JNS sfOk
   MOV SkipFrame,SkipCount
  sfOk:
  JNZ NoSwap
 ENDIF

IFE DEBUG

 ; Wait Retrace
  mov dx,03DAh  ; Input Status Register 1
 Retrace1:
  in al,dx      ; Drawing ?
  test al,08h
 jnz Retrace1	; No - synchronize
 Retrace2:
  in al,dx      ; Drawing ?
  test al,08h
 jz Retrace2	; Yes - wait done

 ; Swap Video
  MOV BX,VGAOfs
  MOV DX,03D4h
  MOV AL,0Ch
  MOV AH,BH
  OUT DX,AX
  INC AL
  MOV AH,BL
  OUT DX,AX

 ; VideoSeg (for VGA.PAS)
  MOV AX,BX
  SHR BX,4
  ADD BX,0A000h
  MOV VideoSeg,BX

 ; New Page
  SUB AX,360*240/4
  JNS SetVGAOfs
   MOV AX,360*240/4*2
  SetVGAOfs:

  MOV VGAOfs,AX
  MOV VideoY,AX

ENDIF
  NoSwap:

  MOV BadColor,0D800h   ; Color pointer

  MOV BX,VideoOfs       ; Location of Text Mode Video Memory
  MOV BadVideo,BX       ; Pointer to this location
  MOV BX,BitmapOfs      ; Location of Bitmap Mode Video Memory
  SUB BX,8*39           ; cancel first "BadLine" Condition
  MOV BadBitmap,BX      ; Pointer to this location

  AND BYTE PTR CIO:[0D011h],255-128 ; clear Raster bit 8

  XOR AX,AX
 NoVBlank:
 MOV Raster,AX

 MOV CIO:[0D012h],AL ; Raster low bits

 TEST AH,1
 JZ  NotRaster8
  OR BYTE PTR CIO:[0D011h],128 ; set Raster bit 8
 NotRaster8:

; RET -> CheckRasterIRQ

UpdateRaster ENDP


BEGINP CheckRasterIRQ
 MOV AX,Raster
 CMP AX,IRQRaster ; IRQ Raster
 JNE NoIrqRaster
  MOV AL,CIO:[0D019h] ; IRQ Flags
  OR  AL,1
  TEST BYTE PTR CIO:[0D01Ah],1; IRQ Mask
  JZ NoIrqRaster1
   OR AL,80h
   OR CIA1,VICFlag ; VICIRQ
   IF DEBUG
    CALLP dbgVICIRQ
   ENDIF
  NoIrqRaster1:
  MOV CIO:[0D019h],AL
 NoIrqRaster:
 RET
CheckRasterIRQ ENDP

;================================================================

BEGINP DrawLine

 ADD Cycles,64 ; default

IF SKIPCOUNT
 TEST SkipFrame,255
 JNZ OutOfScreen
ENDIF

 MOV AX,Raster

 CMP AX,TopOfScreen	; VGA Clipping
 JB  OutOfScreen
 CMP AX,BottomOfScreen
 JAE OutOfScreen

 MOV ES,VGASeg

 TEST Byte Ptr CIO:[0D011h],10h ; Screen Disabled
 JZ DrawBorder

;-- Bottom of screen
 CMP AX,LastLine
 JA  DrawBorder

;-- Bad Line Condition --
 SUB AX,StartLine
 JS  NoBadLine    ; We are Before First Line
 AND AX,7
 MOV TextRow,AX   ; compute this each time !
 JNZ NoBadLine    ; One "BadLine" each 8 lines (0-7)
  SUB Cycles,20   ; need 20 cycles for "bad lines"

;  XOR AX,AX
;  MOV TextRow,AX  ; scan 8 lines for each TextMode Char Line

  MOV AX,SEG @DATA
  MOV ES,AX

 ; copy Colors
  MOV SI,BadColor
  MOV DI,offset ColorMatrix
  MOV DS,CIOSeg
  MOV CX,40/4
  REP MOVSD

  MOV DS,AX

  MOV BadColor,SI

 ; copy Video
  MOV SI,BadVideo
  MOV DI,offset VideoMatrix
  MOV DS,RAMSeg
  MOV CX,40/4
  REP MOVSD

  MOV DS,AX

  MOV BadVideo,SI

 ; Update BadBitmap
  ADD BadBitmap,8*39 ; Each DrawLine skip one byte, BadLines skip what left

  IF DEBUG
   CALLP dbgVIC
  ENDIF

  MOV ES,VGASeg
 NoBadLine:

;-- Draw Text/Graph Line

IFE DEBUG

 MOV AX,Raster
 CMP AX,FirstLine    ; Top Border
 JAE Yes_Draw
  CMP AX,StartLine   ; For YScroll
  JB  DrawBorder     ; Not yet
;  INC TextRow        ; Simulate a line
;  AND TextRow,7
  INC BadBitmap      ; NextLine at Next Byte,NextByte+8 ...
  JMP DrawBorder
 Yes_Draw:

; Draw Line
; - Background
; -- Note that by this way Sprite#0 (background) can be behind
;    Sprite#1 (foreground), with PC64 Sprite#0 can be behind the text and
;    in front of Sprite#1....I suppose that a real C64 do it like PC64

 Call VideoBack     ; Background Color(s)

 MOV AL,CIO:[53275] ; Sprite To Background Priority: 1=Sprite
 AND AL,CIO:[53269] ; Sprite Display Enable: 1=Enable
 JZ NoBackSprite
  Call DrawSprites
 NoBackSprite:

; - Foreground

 MOV AX,Raster       ; Check for ...
 SUB AX,StartLine
 JS  SkipVideoMode   ; Upper Lines and ...
 SUB AX,200
 JNS SkipVideoMode   ; Last Lines

  CALL VideoMode     ; Text/Graphics

;  INC TextRow
;  AND TextRow,7
  INC BadBitmap      ; NextLine at Next Byte,NextByte+8 ...

 SkipVideoMode:

 MOV AL,CIO:[53275] ; Sprite To Background Priority: 1=Sprite
 NOT AL             ; Now only ForeGround Sprites :)
 AND AL,CIO:[53269] ; Sprite Display Enable: 1=Enable
 JZ NoForeSprite
  Call DrawSprites
 NoForeSprite:

; Draw Left Border (override sprite on left border)
 MOV AX,0F02h
 MOV DX,03C4h
 OUT DX,AX
 MOV DI,VideoY
 MOV AL,CIO:[53280] ; BorderColor
 MOV CX,20/4
 REP STOSB

; Draw Right Border (override sprite on right border)
 ADD DI,80
 MOV CX,20/4
 REP STOSB
 MOV VideoY,DI

ENDIF

 MOV ES,ROMSeg ; Restore ES, we don't need VGASeg any more

 OutOfScreen:

 RET

DrawLine ENDP

BEGINP DrawBorder
IFE DEBUG
; Select all planes
 MOV AX,0F02h
 MOV DX,03C4h
 OUT DX,AX
; ES:DI = VideoY
 MOV DI,VideoY
; Draw the Line
 MOV AL,CIO:[53280] ; BorderColor
 MOV AH,AL
 MOV CX,360/8
 REP STOSW
 MOV VideoY,DI
ENDIF
 MOV ES,ROMSeg ; !!!
 RET
DrawBorder ENDP


;=======================================================
BEGINP TextData1 ;-------- get CHARGEN
 ; compute CharsMatrix
  LES DI,CHARGEN
  XOR AH,AH
  MOV SI,TextCols
  DEC SI
 NextMaskTM1:
  MOV AL,[VideoMatrix+SI]
  MOV BX,AX
  SHL BX,3
  ADD BX,TextRow
  MOV AL,ES:[DI+BX] ; CHARGEN
  MOV BX,AX
  MOV AL,[Reverse+BX]
  MOV [CharsMatrix+SI],AL
  DEC SI
 JNS NextMaskTM1
 RET
TextData1 ENDP

BEGINP TextData3 ;-------- get CHARGEN (and  63)
 ; compute CharsMatrix
  LES DI,CHARGEN
  XOR AH,AH
  MOV SI,TextCols
  DEC SI
 NextMaskTM3:
  MOV AL,[VideoMatrix+SI]
  AND AL,63
  MOV BX,AX
  SHL BX,3
  ADD BX,TextRow
  MOV AL,ES:[DI+BX] ; CHARGEN
  MOV BX,AX
  MOV AL,[Reverse+BX]
  MOV [CharsMatrix+SI],AL
  DEC SI
 JNS NextMaskTM3
TextData3 ENDP

BEGINP TextDraw1 ;-------- mono color

 MOV ES,VGASeg
 MOV DI,VideoY
 add di,5	; Left Border Width

 ; put here some code to provide XScroll ... CharsMatrix[] shr XScroll
 ; perhaps we can use VGA scrolling...

 ; draw TextCols chars

 ; TextColor
  mov dx,3C4h
  mov al,02
  mov cx,TextCols
  xor si,si
 NextCharTD1:
  mov ah,[CharsMatrix+SI]
  mov bl,[ColorMatrix+SI]
  test ah,15
  jz SkipTDL1
   out dx,ax
   mov es:[di],bl
  SkipTDL1:
  inc di
  shr ah,4
  jz SkipTDL2
   out dx,ax
   mov es:[di],bl
  SkipTDL2:
  inc di
  inc si
 loop NextCharTD1

 RET
TextDraw1 ENDP

BEGINP TextDraw2 ;---- multi color
 MOV ES,VGASeg
 MOV DI,VideoY
 add di,5

 ; put here some code to provide XScroll ... CharsMatrix[] shr XScroll
 ; perhaps we can use VGA scrolling...

 ; draw TextCols chars

 ; MultiColor
  mov bl,CIO:[53282]
  mov MultiColor+1,bl
  mov bl,CIO:[53283]
  mov MultiColor+0,bl

 ; TextColor
  mov dx,3C4h
  mov al,02
  mov cx,TextCols
  xor si,si
 NextCharTD2:
  mov bl,[ColorMatrix+SI]
  test bl,8
  jnz CharTD2c
  mov ah,[CharsMatrix+SI]
  test ah,15
  jz SkipTD2L1
   out dx,ax
   mov es:[di],bl
  SkipTD2L1:
  inc di
  shr ah,4
  jz SkipTD2L2
   out dx,ax
   mov es:[di],bl
  SkipTD2L2:
  inc di
  inc si
 DoLoopTD2:
 loop NextCharTD2
 RET

 CharTD2c:
  and bl,7
  mov MultiColor+2,bl

  mov bl,[CharsMatrix+SI]
  and bl,3
  jz no_td2_1
   mov ah,1+2
   out dx,ax
   mov ah,[MultiColor+BX-1]
   mov es:[di],ah
  no_td2_1:

  mov bl,[CharsMatrix+SI]
  shr bl,2
  and bl,3
  jz no_td2_2
   mov ah,4+8
   out dx,ax
   mov ah,[MultiColor+BX-1]
   mov es:[di],ah
  no_td2_2:
  inc di

  mov bl,[CharsMatrix+SI]
  shr bl,4
  and bl,3
  jz no_td2_3
   mov ah,1+2
   out dx,ax
   mov ah,[MultiColor+BX-1]
   mov es:[di],ah
  no_td2_3:

  mov bl,[CharsMatrix+SI]
  shr bl,6
  jz no_td2_4
   mov ah,4+8
   out dx,ax
   mov ah,[MultiColor+BX-1]
   mov es:[di],ah
  no_td2_4:
  inc di

  inc si
 JMP DoLoopTD2
TextDraw2 ENDP

BEGINP TextBack1 ;--- Standard Text - Background
 ; plan mask
  mov dx,3C4h
  mov ax,0F02h
  out dx,ax

 ; BackColor
  mov di,VideoY
  add di,5

  mov al,CIO:[0D021h] ; BackColor 0
  mov ah,al
  mov cx,TextCols
  rep stosw

 RET
TextBack1 ENDP

BEGINP TextMode1 ;--- Standard Text - Foreground
 Call TextData1
 JMP  TextDraw1
TextMode1 ENDP

TextBack2 equ TextBack1

BEGINP TextMode2
 Call TextData1
 JMP  TextDraw2
TextMode2 ENDP

BEGINP TextBack3
 ; plan mask
  mov dx,3C4h
  mov ax,0F02h
  out dx,ax

 ; BackColors
  mov eax,CIO:[53280]
  mov dword ptr MultiColor,eax

 ; BackColor
  xor si,si
 mov di,VideoY
 add di,5
  mov cx,TextCols
  xor bh,bh
  NextBack3:
   mov bl,[VideoMatrix+SI]
   inc si
   shr bl,6
   mov al,[MultiColor+bx]
   mov ah,al
   stosw
  Loop NextBack3
 RET
TextBack3 ENDP

BEGINP TextMode3        ; Mono-ForeColor
 Call TextData3
 JMP  TextDraw1
TextMode3 ENDP

TextBack4 equ TextBack3 ; Multi-BackColor

BEGINP TextMode4        ; Multi-ForeColor
 Call TextData3
 JMP  TextDraw2
TextMode4 ENDP

;--------------------------------------------
BEGINP GraphBack1 ;--- Standard Bitmap - BackGround
 ; plan mask
  mov dx,3C4h
  mov ax,0F02h
  out dx,ax

  xor si,si
  mov cx,TextCols
  mov di,VideoY
  add di,5
 NextGB1:
  mov al,[VideoMatrix+SI] ; Get Color
  and al,15
  mov ah,al
  stosw
  inc si
 loop NextGB1

 RET
GraphBack1 ENDP

BEGINP GraphMode1 ;--- Standard Bitmap - ForeGround
 ; compute CharsMatrix
  MOV AX,SEG @DATA
  MOV ES,AX
  MOV DI,Offset CharsMatrix

  MOV SI,BadBitmap

  XOR BH,BH

  MOV CX,TextCols

 NextMaskGM1:
  MOV BL,RAM:[SI]
  MOV AL,[Reverse+BX]
  ADD SI,8
  STOSB
 Loop NextMaskGM1

 MOV ES,VGASeg
 MOV DI,VideoY
 add di,5

 ; plan mask
  mov dx,3C4h
  mov al,02

 ; start loop
  mov cx,TextCols
  xor si,si

 NextCharGM1:
  mov ah,[CharsMatrix+SI]
  mov bl,[VideoMatrix+SI]
  shr bl,4

  test ah,15
  jz SkipGM1L
   out dx,ax
   mov es:[di],bl
  SkipGM1L:

  inc di

  shr ah,4
  jz SkipGM1H
   out dx,ax
   mov es:[di],bl
  SkipGM1H:

  inc di

  inc si
 loop NextCharGM1

 RET
GraphMode1 ENDP

;------------
;BEGINP GraphBack2
;GraphBack2 ENDP
GraphBack2 equ TextBack1 ; BackColor0

BEGINP GraphMode2
 ; compute CharsMatrix
  MOV AX,SEG @DATA
  MOV ES,AX
  MOV DI,Offset CharsMatrix

  MOV SI,BadBitmap

  XOR BH,BH
  MOV CX,TextCols

 NextMaskGM2:
  MOV AL,RAM:[SI]
  ADD SI,8
  STOSB
 Loop NextMaskGM2

 MOV ES,VGASeg
 MOV DI,VideoY
 add di,5

 ; plan mask
  mov dx,3C4h
  mov al,02h

 ; start loop
  mov cx,TextCols
  xor si,si

 NextCharGM2:

 ; MultiColor
  mov bl,[ColorMatrix+SI]
  mov MultiColor+2,bl
  mov bl,[VideoMatrix+SI]
  and bl,15
  mov MultiColor+1,bl
  mov bl,[VideoMatrix+SI]
  shr bl,4
  mov MultiColor+0,bl

 ; Pixels Info

  mov bl,[CharsMatrix+SI]
  shr bl,6
  jz no_gm2_1
   mov ah,1+2
   out dx,ax
   mov ah,[MultiColor+BX-1]
   mov es:[di],ah
  no_gm2_1:

  mov bl,[CharsMatrix+SI]
  shr bl,4
  and bl,3
  jz no_gm2_2
   mov ah,4+8
   out dx,ax
   mov ah,[MultiColor+BX-1]
   mov es:[di],ah
  no_gm2_2:
  inc di

  mov bl,[CharsMatrix+SI]
  shr bl,2
  and bl,3
  jz no_gm2_3
   mov ah,1+2
   out dx,ax
   mov ah,[MultiColor+BX-1]
   mov es:[di],ah
  no_gm2_3:

  mov bl,[CharsMatrix+SI]
  and bl,3
  jz no_gm2_4
   mov ah,4+8
   out dx,ax
   mov ah,[MultiColor+BX-1]
   mov es:[di],ah
  no_gm2_4:
  inc di

  inc si
 loop NextCharGM2

 RET
GraphMode2 ENDP

;--------------
BEGINP GraphBlack
 ; plan mask
  mov dx,3C4h
  mov ax,0F02h
  out dx,ax

 ; BackColor
  mov di,VideoY
  add di,5

  xor ax,ax
  mov cx,TextCols
  rep stosw
 RET
GraphBlack ENDP

GraphBack3 = GraphBlack

BEGINP GraphMode3
 RET
GraphMode3 ENDP

GraphBack4 = GraphBlack
GraphMode4 = GraphMode3

;=======================================================
BEGINP DrawSprites

 MOV SpriteTest,AL

 MOV DL,128 ; Sprite#7
 MOV SI,7   ; SpriteIndex (7-0)

 TestSprite:
  TEST SpriteTest,DL
  JNZ  DrawSprite
 NextSprite:
  DEC SI
  SHR DL,1
  JNZ TestSprite
 RET ; SpriteDone

 DrawSprite:

 MOV BX,SI
 SHL BX,1
 MOV AX,CIO:[53248+BX] ; AL=X AH=Y : Left-Top=24-50
 MOV CX,Raster
 DEC CX
 SUB CL,AH
 JS  NextSprite ; Before the sprite

 TEST CIO:[53271],DL ; Expand 2xY
 JZ Sprite1Y
  SHR CL,1 ; Sprite2Y
 Sprite1Y:

 CMP CL,21
 JAE NextSprite ; After the sprite

 MOV AH,CIO:[53264] ; X bit 8
 AND AH,DL          ; For this sprite
 JZ  SpriteX
  MOV AH,1
 SpriteX:
 CMP AX,24+320 ; Left+ScreenWidth
 JAE NextSprite

 MOV BX,VideoOfs
 MOV BL,RAM:[2040-1024+BX+SI] ; SPRITE BLOCK (in current Video Bank !)
 SHL BX,6    ; * 64 = SPRITE DATA OFFSET...
 ADD BX,Bank ; ... in current Bank

 XOR CH,CH ; Line Number (3 bytes per line)
 ADD BX,CX
 ADD BX,CX
 ADD BX,CX
 MOV DI,BX ; SpriteLine

 TEST CIO:[53276],DL ; MultiColor
 JNZ MultiColorSprite

; Clear SpriteData

 XOR EBX,EBX
 MOV DWORD PTR DS:[SpriteData],EBX
 MOV DWORD PTR DS:[SpriteData+4],EBX

 TEST CIO:[53277],DL ; Expand 2X
 JNZ Sprite2X

  MOV BL,RAM:[DI]   ; Byte 0
  MOV CL,DS:[BX+Reverse]
  MOV BL,RAM:[DI+1] ; Byte 1
  MOV CH,DS:[BX+Reverse]
  MOV WORD PTR DS:[SpriteData],CX

  MOV BL,RAM:[DI+2] ; Byte 2
  MOV CL,DS:[BX+Reverse]
  MOV DS:[SpriteData+2],CL

  MOV CH,6 ; 3 bytes

  JMP Sprite1X

 Sprite2X:

  MOV BL,RAM:[DI]   ; Byte 0
  MOV CL,DS:[BX+DoubleL]
  MOV CH,DS:[BX+DoubleH]
  MOV WORD PTR DS:[SpriteData],CX

  MOV BL,RAM:[DI+1] ; Byte 1
  MOV CL,DS:[BX+DoubleL]
  MOV CH,DS:[BX+DoubleH]
  MOV WORD PTR DS:[SpriteData+2],CX

  MOV BL,RAM:[DI+2] ; Byte 2
  MOV CL,DS:[BX+DoubleL]
  MOV CH,DS:[BX+DoubleH]
  MOV WORD PTR DS:[SpriteData+4],CX

  MOV CH,12 ; 6 bytes

 Sprite1X:

 ; Clipping -- bad way...should skip not used data with BX & DI
  MOV BX,23
  SUB BX,AX
  JS  NoSpriteClipping
   MOV CL,BL
   INC CL
   XOR EBX,EBX
   DEC EBX
   SHL EBX,CL
   AND DWORD PTR SpriteData,EBX
  NoSpriteClipping:

 PUSH DX    ;-- Sprite#

 ; Shift Data -- shift on 64 bits (either x-expanded or not)
  MOV CL,AL
  AND CL,3
  JZ NoSpriteShift
   MOV EBX,dword ptr SpriteData
   MOV EDX,dword ptr SpriteData+4
   SHLD EDX,EBX,CL
   SHL  EBX,CL
   MOV dword ptr SpriteData,EBX
   MOV dword ptr SpriteData+4,EDX
   INC CH ; 1 byte more
  NoSpriteShift:

 ; need a Collision detection...
 ; - with CharsMatrix for Sprite/Background
 ; - with something else for Sprite/Sprite

 ; Target
  MOV DI,VideoY
  SHR AX,2
  DEC AX
  ADD DI,AX

 ; plan mask
  MOV DX,03C4h
  MOV AL,02h
  MOV CL,CIO:[53287+SI] ; Sprite Color
  XOR BX,BX

  NextSpriteData:
   MOV AH,DS:[SpriteData+BX]
   TEST AH,15
   JZ SkipSpriteH
    OUT DX,AX
    MOV ES:[DI],CL
   SkipSpriteH:
   DEC CH
   JZ SpriteDataDone
   INC DI
   SHR AH,4
   JZ SkipSpriteL
    OUT DX,AX
    MOV ES:[DI],CL
   SkipSpriteL:
   INC DI
   INC BX
   DEC CH
  JNZ NextSpriteData

SpriteDataDone:
 POP DX ;-- Sprite#
 JMP NextSprite

MultiColorSprite: ;-----------------------------------------------

 ; Get SpriteData
  MOV EBX,RAM:[DI]
  MOV DWORD PTR SpriteData,EBX

 ; Colors
  mov bl,CIO:[53285]    ; MultiColor Sprite - Color 1
  mov MultiColor+0,bl
  mov bl,CIO:[53287+SI] ; Sprite# Color
  mov MultiColor+1,bl
  mov bl,CIO:[53286]    ; MultiColor Sprite - Color 2
  mov MultiColor+2,bl

  PUSH DX
  PUSH SI

  MOV DI,AX    ; SpriteX
  MOV AX,1102h ; First Pixel
  MOV CL,6     ; First Color
  XOR SI,SI    ; First Data Byte

  TEST CIO:[53277],DL ; Expand 2x
  JNZ MultiColorSprite2x

 ; Skip LeftBorder
  CMP DI,24
  JAE BeginDraw_mcs_1x

   MOV SI,24
   SUB SI,DI
   SHR SI,3  ; div 8 -> SpriteData adjustement (8 pixels/octet)
   CMP SI,3
   JAE MultiColorSpriteDone ; SpriteX=0 : invisible sprite

   AND DI,7
   JNZ mcs1x_24
    ADD DI,8
   mcs1x_24:
   ADD DI,24-8

  BeginDraw_mcs_1x:
   MOV BX,DI
   AND BX,3
   JZ NoShiftMCS1x
    MOV BH,CL
    MOV CL,BL
    ROL AH,CL
    MOV CL,BH
   NoShiftMCS1x:

   SHR DI,2
   DEC DI
   ADD DI,VideoY
   mov dx,03C4h
   xor bh,bh

   NextMultiColorSprite:

    mov bl,[SpriteData+SI]
    shr bl,cl

    and bl,3
    jz no_mcs_1
     out dx,ax
     mov ch,[MultiColor+BX-1]
     mov es:[di],ch
    no_mcs_1:
    rol ah,1
    jnc no_mcs_1c
     inc di
    no_mcs_1c:

    and bl,3
    jz no_mcs_2
     out dx,ax
     mov es:[di],ch
    no_mcs_2:
    rol ah,1
    jnc no_mcs_2c
     inc di
    no_mcs_2c:

    sub cl,2
    jns NextMultiColorSprite
    mov cl,6
    inc si
    cmp si,3
   jne NextMultiColorSprite

 JMP MultiColorSpriteDone

 MultiColorSprite2X: ;--------------

 ; Skip LeftBorder
  CMP DI,24
  JAE BeginDraw_mcs_2x

   MOV SI,24
   SUB SI,DI
   SHR SI,4  ; div 16 -> SpriteData Ajdustement (16 pixels/octet)
   JZ mcs2x_24
    ADD DI,16
   mcs2x_24:

  BeginDraw_mcs_2x:
   MOV BX,DI
   AND BX,3
   JZ NoShiftMCS2x
    MOV BH,CL
    MOV CL,BL
    ROL AH,CL
    MOV CL,BH
   NoShiftMCS2x:

   SHR DI,2
   DEC DI
   ADD DI,VideoY
   mov dx,03C4h
   xor bh,bh

   NextMultiColorSprite2x:

    mov bl,[SpriteData+SI]
    shr bl,cl

    and bl,3
    jz no_mcs2x_1
     out dx,ax
     mov ch,[MultiColor+BX-1]
     mov es:[di],ch
    no_mcs2x_1:
    rol ah,1
    jnc no_mcs2x_1c
     inc di
    no_mcs2x_1c:

    and bl,3
    jz no_mcs2x_2
     out dx,ax
     mov es:[di],ch
    no_mcs2x_2:
    rol ah,1
    jnc no_mcs2x_2c
     inc di
    no_mcs2x_2c:

    and bl,3
    jz no_mcs2x_3
     out dx,ax
     mov es:[di],ch
    no_mcs2x_3:
    rol ah,1
    jnc no_mcs2x_3c
     inc di
    no_mcs2x_3c:

    and bl,3
    jz no_mcs2x_4
     out dx,ax
     mov es:[di],ch
    no_mcs2x_4:
    rol ah,1
    jnc no_mcs2x_4c
     inc di
    no_mcs2x_4c:

    sub cl,2
    jns NextMultiColorSprite2x
    mov cl,6
    inc si
    cmp si,3
   jne NextMultiColorSprite2x

 MultiColorSpriteDone:

 POP SI
 POP DX
 JMP NextSprite

DrawSprites ENDP
;=======================================================
BEGINP NewBank      ; MOS 6526 Complex Interface Adpater (CIA) #2
 MOV AL,CIO:[56576] ; Data Port A
 MOV AH,CIO:[56578] ; Data Direction Register - Port A
 NOT AL
 AND AL,AH
 AND AX,3
 SHL AX,14
 MOV Bank,AX
; NewBase...
NewBank ENDP

BEGINP NewBase
; VIDEO
 MOV BL,CIO:[53272] ; VIC Memory Control Register
 MOV AL,BL
 AND AX,00F0h
 SHL AX,6
 ADD AX,Bank
 MOV DX,VideoOfs
 MOV VideoOfs,AX
 SUB AX,DX
 ADD BadVideo,AX
; CHARGEN
 MOV AL,BL
 AND AX,000Eh
 SHL AX,10
 ADD AX,Bank
 MOV DX,AX
 AND DX,07000h
 CMP DX,01000h
 MOV DX,RAMSeg
 JNE RAMChars
  MOV DX,ROMSeg
  AND AX, 0FFFh
  OR  AX,0D000h
 RAMChars:
 MOV WORD PTR CHARGEN+0,AX
 MOV WORD PTR CHARGEN+2,DX
; BITMAP
 MOV AL,BL
 AND AX,0008h
 SHL AX,10
 ADD AX,Bank
 MOV DX,BitmapOfs
 MOV BitmapOfs,AX
 SUB AX,DX
 ADD BadBitmap,AX

 IF DEBUG
  CALLP dbgVICBase
 ENDIF
 RET
NewBase ENDP

BEGINP NewStart ; recompute Bad lines offsets

 ; Reset pointers

  MOV BadColor,0D800h	; Color pointer
  MOV BX,VideoOfs	; Location of Text Mode Video Memory
  MOV BadVideo,BX       ; Pointer to this location
  MOV BX,BitmapOfs      ; Location of Bitmap Mode Video Memory
  SUB BX,8*39           ; cancel first "BadLine" Condition
  MOV BadBitmap,BX      ; Pointer to this location

 ; Check Raster

  MOV AX,Raster 	; from Current Raster
  SUB AX,StartLine	; after StartLine
  JS  NewStart_Done     ; ...before StartLine

  MOV BX,AX
  AND BX,7
  MOV TextRow,BX
  ADD BadBitmap,BX

  SHR AX,3		; /8
  OR  AX,AX
  JZ  NewStart_Done	; First Line
  INC AX
  MOV CX,AX
  NewStart_Loop:
   ADD BadColor,40
   ADD BadVideo,40
   ADD BadBitmap,8*40
  LOOP NewStart_Loop

  NewStart_Done:
  RET
NewStart ENDP

;=======================================================
; POKE DI,AL

BEGINP NewVideoMode
 MOV AL,CIO:[53265] ; Control Register 1
 AND AL,60h         ; - Extended Color & Bitmap Mode
 MOV BL,CIO:[53270] ; Control Register 2
 AND BX,10h         ; - Multi-Color Mode
 OR  BL,AL
 SHR BL,3
 MOV AX,[VideoModes+BX]
 MOV VideoMode,AX
 MOV AX,[VideoBacks+BX]
 MOV VideoBack,AX
 IF DEBUG
  CALLP dbgVICMode
 ENDIF
 RET
NewVideoMode ENDP

BEGINP wDxxx      ; store
 MOV CIO:[DI],AL
 JMP NEXT
wDxxx ENDP

BEGINP wDx11        ; Control Register 1 - 53265
 MOV CIO:[DI],AL

comment ! RollBack
                                +------+
            +------+            | YS=0 |
  Raster----| YS=3 |--+------+--+------+--
            +------+  | YS=7 |
                      +------+

RollBack !

 MOV BX,AX
 AND BX,07          ; Y-Scroll (0..7, default 3)

comment !
 MOV DX,BX
 SUB DX,YScroll
 JZ  NoYChange      ; NoChange

 JS  NoRollBack
 CMP DX,TextRow     ; = RollBack if DX>=TextRow
 JB  NoRollBack
  SUB BadColor,40
  SUB BadVideo,40
  SUB BadBitmap,8*40
 NoRollBack:
!
 MOV YScroll,BX
 ADD BX,51-3
 MOV StartLine,BX   ; First Line for "BadLine" condition

 NoYChange:

 TEST AL,8
 JNZ lines25
  MOV FirstLine,55  ; Top Border
  MOV LastLine,246  ; Bottom Border
  JMP Lines_done
 lines25:
  MOV FirstLine,51
  MOV LastLine,250
 lines_done:

 SHR AL,7
 CMP AL,byte ptr IRQRaster+1
 JE  SkipD011
  MOV byte ptr IRQRaster+1,AL
  Call CheckRasterIRQ
 SkipD011:

 Call NewVideoMode
; Call NewStart

 JMP NEXT
wDx11 ENDP

BEGINP wDx12        ; Write Raster Value for Compare IRQ - 53266
 CMP byte ptr IRQRaster,AL
 JE SkipD012
  MOV byte ptr IRQRaster,AL
  Call CheckRasterIRQ
 SkipD012:
 JMP NEXT
wDx12 ENDP

BEGINP wDx16        ; Control Register 2 - 53270
 IF DEBUG
  CALLP dbgDx16Before
 ENDIF
 MOV CIO:[DI],AL
 IF DEBUG
  CALLP dbgDx16After
 ENDIF
 Call NewVideoMode
 JMP Next
wDx16 ENDP

BEGINP wDx18        ; Memory Base - 53272
 MOV CIO:[DI],AL
 CALL NewBase
 JMP NEXT
wDx18 ENDP

BEGINP wDx19        ; Interrupt Flag Register
 NOT AL
 AND AL,0Fh
 AND AL,CIO:[DI]
 AND CIA1,255-VICFlag; CLEAR IRQ
 MOV AH,CIO:[0D01Ah] ; IRQ Mask
 AND AH,AL           ; IRQ Flag
 JZ noIRQDx19
  OR AL,80h
 noIRQDx19:
 MOV CIO:[DI],AL
 JMP NEXT
wDx19 ENDP

BEGINP wDx1A        ; IRQ Mask Register
 AND AL,0Fh
 MOV CIO:[DI],AL
 MOV AH,CIO:[0D019h] ; IRQ Flag
 AND AL,AH
 JZ noIRQDx1A
  OR AH,80h
  OR CIA1,VICFlag ; VICIRQ
  JMP FlagDx1A
 noIRQDx1A:
  AND AH,7Fh
  AND CIA1,255-VICFlag
 FlagDx1A:
 MOV CIO:[0D019h],AH
 JMP NEXT
wDx1A ENDP

BEGINP wDx2x        ; Border Color ... Sprite 7 Color
 AND AL,15
 MOV CIO:[DI],AL
 JMP NEXT
wDx2x ENDP

;=======================
; AL=PEEK(DI)
BEGINP rDxxx
 MOV AL,CIO:[DI]
 RET
rDxxx ENDP

BEGINP rDnul
 MOV AL,CIO:[DI]
 MOV BYTE PTR CIO:[DI],0
 RET
rDnul ENDP

BEGINP rDx16
 MOV AL,CIO:[DI]
 OR  AL,0C0h
 RET
rDx16 ENDP

BEGINP rDx18
 MOV AL,CIO:[DI]
 OR  AL,01h
 RET
rDx18 ENDP

BEGINP rDx19
 MOV AL,CIO:[DI]
 OR  AL,70h
 RET
rDx19 ENDP

BEGINP rDx1A
 MOV AL,CIO:[DI]
 OR  AL,0F0h
 RET
rDx1A ENDP
